/***************************************************************************
    file	         : kb_locator.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


/*  ------------------------------------------------------------------  */
/*  QT3/Linux								*/
/*  ------------------------------------------------------------------  */


#if		__KB_TKC

#include	<stdio.h>
#include	<stdlib.h>

#include	<qstring.h>
#include 	<qdir.h>

static	QString	rootdir	= ROOTDIR ;

#define	DATAPATH	"/share/apps/rekallqt/"
#define	DOCPATH		"/share/doc/HTML/en/rekallqt/"

/*  locateFile	: Locate a file of specified type			*/
/*  type	: const char *	  : File type				*/
/*  name	: const QString & : File name				*/
/*  (returns)	: QString	  : Path				*/

QString	locateFile
	(	const char	*type,
		const QString	&name
	)
{
//	fprintf	(stderr, "locateFile: %s: %s (with %s)\n",
//			 type,
//			 (const char *)name,
//			 (const char *)rootdir) ;

	if (qstrcmp (type, "appdata") == 0)
		return	rootdir + DATAPATH + name ;

	if (qstrcmp (type, "doc") == 0)
		return	rootdir + DOCPATH  + name ;

	return	QString::null ;
}

/*  locateDir	: Locate a directory of specified type			*/
/*  type	: const char *	  : Directory type			*/
/*  name	: const QString & : Directory name			*/
/*  (returns)	: QString	  : Path				*/

QString	locateDir
	(	const char	*type,
		const QString	&
	)
{
	/* The name is never used here. The argument exists since under	*/
	/* KDE there seems to be no way to locate an application	*/
	/* directory without naming a file that will be found in it.	*/
	return	locateFile   (type, "") ;
}

/*  setRootDir	: Set different root directory				*/
/*  _rootdir	: const QString & : New root directory name		*/
/*  (returns)	: void		  :					*/

void	setRootDir
	(	const QString	&_rootdir
	)
{
	rootdir	= _rootdir ;
	fprintf	(stderr, "setRootDir(%s)\n", (const char *)rootdir) ;
}

/*  getRootDir	: Get root directory					*/
/*  (returns)	: QString &	: Directory name			*/

QString	getRootDir ()
{
	fprintf	(stderr, "getRootDir(%s)\n", (const char *)rootdir) ;
	return	rootdir	;
}

#endif
