/***************************************************************************
    file	         : kb_ascii.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<qstring.h>
#include	<qcolor.h>
#include	<qsize.h>
#include	<qpoint.h>
#include	<qrect.h>
#include	<qdatetime.h>

#include	"kb_ascii.h"

QString	KBAscii::text
	(	const	QColor	&c
	)
{
	return	c.name() ;
}

QString	KBAscii::text
	(	const	QPoint	&p
	)
{
	return	QString().sprintf ("(%d,%d)", p.x(), p.y()) ;
}

QString	KBAscii::text
	(	const	QSize	&s
	)
{
	return	QString().sprintf ("(%d,%d)", s.width(), s.height()) ;
}

QString	KBAscii::text
	(	const	QRect	&r
	)
{
	return	QString().sprintf ("(%d,%d,%d,%d)", r.left(), r.top(), r.width(), r.height()) ;
}

QString	KBAscii::text
	(	const	QDate	&d
	)
{
	return	d.toString() ;
}

QString	KBAscii::text
	(	const	QTime	&t
	)
{
	return	t.toString() ;
}

QString	KBAscii::text
	(	cchar 		*data, 
		uint		len
	)
{
	QString	res	;
	uint	offset	;

	for (offset = 0 ; (offset < len) && (offset < 16) ; offset += 1)
		res += QString().sprintf("%02x ", data[offset] & 0xff) ;

	if (offset <= len) res += "...." ;
	return	res	;
}

