/***************************************************************************
    file	         : kb_methdict.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_METHDICT_H
#define	__KB_METHDICT_H

#include 	"libkbase_exports.h"

#include	<qptrlist.h>

class	QDomElement	;

/*  KBMethDictArg							*/
/*  -------------							*/
/*  Class used to store details of an argument.				*/

class	LIBKBASE_API	KBMethDictArg
{
public	:

	QString		m_name		;
	QString		m_type		;
	QString		m_comment	;
	bool		m_opt		;

	inline	KBMethDictArg	()
	{
		m_opt	= false	;
	}

	KBMethDictArg	(const QDomElement &)	;
}	;

/*  KBMethDictEntry							*/
/*  ---------------							*/
/*  Structure used to handle dictionary entries. Only a class so that	*/
/*  we have automatic initialisation.					*/

class	LIBKBASE_API	KBMethDictEntry
{
	QString		asText		(bool)		;

public	:

	QString				m_class		;
	QString				m_name		;
	QString				m_comment	;
	QString				m_return	;
	QValueList<KBMethDictArg>	m_args		;

	QString		description	()		;
	QString		substitute	()		;
}	;

/*  KBMethDict								*/
/*  ----------								*/

class	LIBKBASE_API	KBMethDict
{
	QPtrList<KBMethDictEntry>		m_entries	;

	void		loadFile	(const QString &) ;

public	:

	KBMethDict	(QString)	;

	QPtrList<KBMethDictEntry>	getMethods (const QString &) ;
}	;

#endif	// __KB_METHDICT_H
