/***************************************************************************
    file	         : kb_prompt.h
    copyright            : (C) 1999,2000,
			       2001,2002,2003,2004,2005 by Mike Richardson
			   (C) 2001,2002,2003,2004,2005 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_PROMPTDLG
#define	_KB_PROMPTDLG


#include	"libkbase_exports.h"
#include	"kb_dialog.h"

#include	<qmessagebox.h>

class	RKLineEdit	;
class	RKComboBox	;
class	RKVBox		;
class	RKHBox		;
class	KBDBInfo	;

/*  KBMessageBoxYNAC							*/
/*  ----------------							*/
/*  Yes/No/All/Cancel prompt dialog					*/

class	LIBKBASE_API	KBMessageBoxYNAC : public KBDialog
{
	Q_OBJECT

	RKPushButton	*addButton
			(	RKHBox 		*,
				const QString	&,
				const QString	&,
				const char	*
			)	;

protected slots	:

	void	slotYes		()	;
	void	slotNo		()	;
	void	slotYesAll	()	;
	void	slotCancel	()	;

public	:

	enum	ActRC
	{	ActYes		= QMessageBox::Yes,
		ActNo		= QMessageBox::No,
		ActYesAll	= QMessageBox::YesAll,
		ActCancel	= QMessageBox::Cancel,
		ActSingle	= 0x00ffffff
	}	;

	KBMessageBoxYNAC
	(	QWidget		*parent,
		const QString	&text,
		const QString	&caption	= QString::null,
		const QString	&buttonYes	= QString::null,
		const QString	&buttonNo	= QString::null,
		const QString	&buttonYesAll	= QString::null,
		const QString	&buttonCancel	= QString::null
	)	;

	static	ActRC	query
		(	QWidget		*parent,
			const QString	&text,
			const QString	&caption	= QString::null,
			const QString	&buttonYes	= QString::null,
			const QString	&buttonNo	= QString::null,
			const QString	&buttonYesAll	= QString::null,
			const QString	&buttonCancel	= QString::null
		)	;

	static	ActRC	query
		(	QWidget		*parent,
			const QString	&text,
			ActRC		actRC,
			const QString	&caption	= QString::null,
			const QString	&buttonYes	= QString::null,
			const QString	&buttonNo	= QString::null,
			const QString	&buttonYesAll	= QString::null,
			const QString	&buttonCancel	= QString::null
		)	;
}	;

/*  ------------------------------------------------------------------	*/


/*  KBPromptDlg								*/
/*  -----------								*/
/*  Basic prompt dialog.						*/

class	LIBKBASE_API	KBPromptDlg : public KBDialog
{
	Q_OBJECT

protected :

	RKLineEdit	*m_tValue	;
	QString		&m_value	;

protected slots :

	virtual	void	accept	()	;

public	:

	KBPromptDlg (const QString &, const QString &, QString &) ;
       ~KBPromptDlg () ;
}	;

/*  KBPromptDlg								*/
/*  -----------								*/
/*  Basic save dialog, showing combo box of possible document		*/
/*  locations.								*/

class	LIBKBASE_API	KBPromptSaveDlg : public KBDialog
{
	Q_OBJECT

protected :

	RKVBox		*m_layout	;

	RKLineEdit	*m_tValue	;
	RKComboBox	*m_cWhere	;
	QString		&m_value	;
	QString		&m_where	;
	bool		m_incfiles	;

protected :

	inline	RKVBox	*mainLayout ()
	{
		return	m_layout	;
	}


protected slots :

	virtual	void	accept	()	;

public	:

	KBPromptSaveDlg (const QString &, const QString &, QString &, QString &, KBDBInfo *, bool) ;
       ~KBPromptSaveDlg () ;

	virtual	int	exec	()	;
}	;


class	LIBKBASE_API	KBChoiceDlg : public KBDialog
{
	Q_OBJECT

	RKComboBox	*m_cValues	;
	QString		&m_value	;

protected slots :

	virtual	void	accept () ;

public	:

	KBChoiceDlg (const QString &, const QString &, QStringList &, QString &) ;
       ~KBChoiceDlg () ;
}	;

extern	bool	LIBKBASE_API	doPrompt
		(	const	QString	&caption,
			const	QString	&message,
			QString		&value
		)	;

extern	bool	LIBKBASE_API	doPromptSave
		(	const QString	&caption,
			const QString	&message,
			QString		&value,
			QString		&where,
			KBDBInfo	*dbInfo,
			bool		incfiles
		)	;


#endif	// _KB_PROMPTDLG
