/***************************************************************************
    file	         : kb_test.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_classes.h"
#include	"kb_test.h"
#include	"kb_node.h"

/*  KBTest								*/
/*  KBTest	: Construcutor for a test object			*/
/*  owner	: KBNode *	: Owning node				*/
/*  name	: cchar *	: Test name				*/
/*  (returns)	: KBTest	:					*/

KBTest::KBTest
	(	KBNode		*owner,
		cchar		*name
	)
	:
	KBEvent	(owner, name, "", KAF_EVCS|KAF_LOOSE)
{
	if (owner != 0) owner->addTest (this) ;
}

/*  KBTest								*/
/*  KBTest	: Construcutor for a test object			*/
/*  owner	: KBNode *	: Owning node				*/
/*  entant	: KBTest *	: Extant test				*/
/*  (returns)	: KBTest	:					*/

KBTest::KBTest
	(	KBNode		*owner,
		KBTest		*extant
	)
	:
	KBEvent	(owner, extant->getName(), "", KAF_EVCS|KAF_LOOSE)
{
	if (owner != 0) owner->addTest (this) ;

	setValue  (extant->getValue ()) ;
	setValue2 (extant->getValue2()) ;
}

/*  KBTest								*/
/*  ~KBTest	: Destrucutor for a test object				*/
/*  (returns)	:		:					*/

KBTest::~KBTest ()
{
}

void	KBTest::setName
	(	const QString	&name
	)
{
	m_name	= name	;
}

/*  KBTest								*/
/*  setOwner	: Set tests's owner object				*/
/*  owner	: KBNode *	: Owner					*/
/*  (returns)	: void		:					*/

void	KBTest::setOwner
	(	KBNode		*owner
	)
{
	/* This method is typically used when the user OK's on a	*/
	/* property dialog, and updated tests are returned to the	*/
	/* owner.							*/
	m_owner = owner ;
	m_owner->addTest (this) ;
}

/*  KBTest								*/
/*  printAttr	: Print attribute					*/
/*  attrText	: QString &	: Result text for attribute output	*/
/*  nodeText	: QString &	: Result text for node output		*/
/*  indent	: int		: Indent depth for node output		*/
/*  flat	: bool		: Generate flatened version		*/
/*  (returns)	: void		:					*/

void	KBTest::printAttr
	(	QString		&attrText,
		QString		&nodeText,
		int		indent,
		bool		flat
	)

{
	if (!getValue ().isEmpty())
	{
		nodeText += QString("%1<test name=\"%2\">\n" ).arg("", indent).arg(m_name) ;
		nodeText += KBAttr::escapeText (getValue (), false) ;
		nodeText += QString("%1</test>\n" ).arg("", indent) ;
	}

	if (!getValue2().isEmpty() && ((m_nFlags & KAF_EVCS) != 0))
	{
		nodeText += QString("%1<test2 name=\"%2\">\n").arg("", indent).arg(m_name) ;
		nodeText += KBAttr::escapeText (getValue2(), false) ;
		nodeText += QString("%1</test2>\n").arg("", indent) ;
	}
}

