/***************************************************************************
    file	         : browser.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>

#if		__KB_AUTOMOC
#include	"browser.moc"
#else
#include	"browser.h"
#endif

#include	"viewer.h"

#include	<qmessagebox.h>
#include	<qprocess.h>
#include	<qfileinfo.h>


SOHelpBrowser::SOHelpBrowser
	(	QWidget		*parent,
		SOHelpViewer	*viewer,
		const char 	*name
	)
	:
	QTextBrowser	(parent, name),
	m_viewer	(viewer),
	m_noScroll	(false)
{
}

QString	SOHelpBrowser::findWebBrowser ()
{
	QStringList path 	= QStringList::split (':', getenv("PATH")) ;
	QStringList browsers	;

	browsers.append	("konqueror"	) ;
	browsers.append	("mozilla"	) ;
	browsers.append	("galeon"	) ;
	browsers.append	("opera"	) ;
	browsers.append	("netscape"	) ;
	browsers.append	("firebird"	) ;

	QStringList::iterator	browserIter	;
	QStringList::iterator	pathIter	;

	for (browserIter = browsers.begin() ; browserIter != browsers.end() ; browserIter++)
		for (pathIter = path.begin() ; pathIter != path.end() ; pathIter++)
		{
			QString	file	= (*pathIter) + "/" + (*browserIter) ;
			if (QFileInfo(file).isExecutable()) return file ;
		}

	return	QString::null	;
}

void	SOHelpBrowser::setSource
	(	const QString	&source,
		const QString	&name
	)
{
	fprintf
	(	stderr,
		"SOHelpBrowser::setSource: [%s][%s]\n",
		source.latin1(),
		name  .latin1()
	)	;

	if (source.isEmpty())
		return	;


	if (source.left(7) == "http://")
	{
		QString	webBrowser = findWebBrowser () ;

		if (webBrowser.isEmpty())
		{
			QMessageBox::information
			(	m_viewer,
				tr("Help"),
				tr("Cannot find a web browser")
			)	;
		}

		QProcess *proc = new QProcess() ;

		proc->addArgument(webBrowser) ;
		proc->addArgument(source) ;
		proc->launch	 ("" ) ;
		return;
	}

	QTextBrowser::setSource  (source + "#" + name) ;
}


void	SOHelpBrowser::blockScrolling
	(	bool		noScroll
	)
{
	m_noScroll	= noScroll ;
}

void	SOHelpBrowser::ensureCursorVisible ()
{
	if (!m_noScroll)
		QTextBrowser::ensureCursorVisible () ;
}
