/***************************************************************************
    file	         : kb_blockproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_BLOCKPROXY_H
#define	__KB_BLOCKPROXY_H


class	KBKJSInterpreter	;

/*  KBBlockProxy							*/
/*  ------------							*/
/*  Proxy class for Rekall blocks ....					*/

class	KBBlockProxy : public KBItemProxy
{
protected :

	KBBlock		*m_block	;

public	:

	KBBlockProxy	(KBKJSInterpreter *, KBBlock *) ;
	~KBBlockProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;

protected :

	class MethodImp : public KBItemProxy::MethodImp
	{
	protected :

		virtual	KJS::Value callBase
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		const KBBlockProxy	*m_block	;

	public	:

		MethodImp	(KBMethodSpec *, const KBBlockProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_gotoQueryRow	   = IDB_BLOCK +  1 ;
		static	const uint	id_doAction	   = IDB_BLOCK +  2 ;
		static	const uint	id_firstRecord	   = IDB_BLOCK +  3 ;
		static	const uint	id_previousRecord  = IDB_BLOCK +  4 ;
		static	const uint	id_nextRecord	   = IDB_BLOCK +  5 ;
		static	const uint	id_lastRecord	   = IDB_BLOCK +  6 ;
		static	const uint	id_addRecord	   = IDB_BLOCK +  7 ;
		static	const uint	id_saveRecord	   = IDB_BLOCK +  8 ;
		static	const uint	id_deleteRecord	   = IDB_BLOCK +  9 ;
		static	const uint	id_startQuery	   = IDB_BLOCK + 10 ;
		static	const uint	id_executeQuery	   = IDB_BLOCK + 11 ;
		static	const uint	id_cancelQuery	   = IDB_BLOCK + 12 ;
		static	const uint	id_getNumRows	   = IDB_BLOCK + 13 ;
		static	const uint	id_getQueryRow	   = IDB_BLOCK + 14 ;
		static	const uint	id_overLimit	   = IDB_BLOCK + 15 ;
		static	const uint	id_isInQuery	   = IDB_BLOCK + 16 ;
		static	const uint	id_getRowValue	   = IDB_BLOCK + 17 ;
		static	const uint	id_setRowValue	   = IDB_BLOCK + 18 ;
		static	const uint	id_invalidControls = IDB_BLOCK + 19 ;
		static	const uint	id_setUserFilter   = IDB_BLOCK + 20 ;
		static	const uint	id_setUserSorting  = IDB_BLOCK + 21 ;
		static	const uint	id_reload          = IDB_BLOCK + 22 ;
		static	const uint	id_saveAsNew       = IDB_BLOCK + 23 ;
		static	const uint	id_saveUnchecked   = IDB_BLOCK + 24 ;
		static	const uint	id_gotoQueryRowByKey
							   = IDB_BLOCK + 25 ;
		static	const uint	id_changedControls = IDB_BLOCK + 26 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_BLOCKPROXY_H
